/*
 * Copyright (C) 1997-2004, R3vis Corporation.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA, or visit http://www.gnu.org/copyleft/lgpl.html.
 *
 * Original Contributor:
 *   Wes Bethel, R3vis Corporation, Marin County, California
 * Additional Contributor(s):
 *
 * The OpenRM project is located at http://openrm.sourceforge.net/.
 */
/*
 * $Id: rmversion.c,v 1.9 2004/04/18 17:04:20 wes Exp $
 * Version: $Name: OpenRM-devel-1-5-2-3 $
 * $Revision: 1.9 $
 * $Log: rmversion.c,v $
 * Revision 1.9  2004/04/18 17:04:20  wes
 * Updated for 1.5.2
 *
 * Revision 1.8  2004/03/10 01:47:56  wes
 * 1.5.2-alpha
 *
 * Revision 1.7  2004/01/19 17:10:00  wes
 * Changed rev to 1.5.1 for release.
 *
 * Revision 1.6  2004/01/16 16:50:35  wes
 * Updated copyright line for 2004, changed version to 1.5.1-beta.
 *
 * Revision 1.5  2003/10/03 19:24:18  wes
 * Updated version to 1.5.1-devel.
 *
 * Revision 1.4  2003/06/20 01:39:35  wes
 * Updated version to 1.5.0.
 *
 * Revision 1.3  2003/04/05 14:14:00  wes
 * Version = 1.5.0-alpha.
 *
 * Revision 1.2  2003/02/02 02:07:16  wes
 * Updated copyright to 2003.
 *
 * Revision 1.1.1.1  2003/01/28 02:15:23  wes
 * Manual rebuild of rm150 repository.
 *
 * Revision 1.14  2003/01/16 22:21:17  wes
 * Updated all source files to reflect new organization of header files:
 * all header files formerly located in include/rmaux, include/rmi, include/rmv
 * are now located in include/rm.
 *
 * Revision 1.13  2002/12/02 16:24:56  wes
 * Bug fixes:
 * (1) fixed memory leak in rmPrimitiveSetText;
 * (2) fixed problem with textProps not being applied to 2nd and later
 * strings in an RM_TEXT text primitive.
 *
 * Revision 1.12  2002/08/17 15:15:23  wes
 * Updated version to 1.4.3.
 *
 * Revision 1.11  2002/04/30 19:36:47  wes
 * Changed rev from 1.4.1 to 1.4.2.
 *
 * Revision 1.10  2001/10/15 00:13:28  wes
 * v1.4.1
 *
 * Revision 1.9  2001/07/15 17:13:05  wes
 * Changed version number from v1.4.0-beta1 to v1.4.0.
 *
 * Revision 1.8  2001/06/03 20:51:18  wes
 * v140-beta1
 *
 * Revision 1.7  2001/03/31 17:12:39  wes
 * v1.4.0-alpha-2 checkin.
 *
 * Revision 1.6  2000/12/03 22:35:39  wes
 * Mods for thread safety.
 *
 * Revision 1.5  2000/05/17 14:25:30  wes
 * Changed version number to 1.3.0.
 *
 * Revision 1.4  2000/04/20 17:42:15  wes
 * Updated to version 1.2.1.
 *
 * Revision 1.3  2000/04/20 16:29:47  wes
 * Documentation additions/enhancements, some code rearragement.
 *
 * Revision 1.2  2000/02/29 23:43:53  wes
 * Compile warning cleanups.
 *
 * Revision 1.1.1.1  2000/02/28 21:29:40  wes
 * OpenRM 1.2 Checkin
 *
 * Revision 1.1.1.1  2000/02/28 17:18:48  wes
 * Initial entry - pre-RM120 release, source base for OpenRM 1.2.
 *
 */

#include <rm/rm.h>
#include "rmprivat.h"

static char version[] = "(v1.5.2)";
static char rmsgbanner[] = "OpenRM Scene Graph %s, \nCopyright (C) 1999-2004, R3vis Corporation.";

/* PRIVATE */
int
private_rmHello (void)
{
    char bigbuf[512];

    /* everybody gets the copyright notice */
    sprintf(bigbuf, rmsgbanner, version);
    rmNotice(bigbuf);

    return(1);
}
/* EOF */
